
import
  preserves, std/tables

type
  NoiseDescriptionDetail* = NoiseServiceSpec
  NoisePreSharedKeysKind* {.pure.} = enum
    `present`, `invalid`, `absent`
  NoisePreSharedKeysPresent* {.preservesDictionary.} = object
    `preSharedKeys`*: seq[seq[byte]]

  NoisePreSharedKeysInvalid* {.preservesDictionary.} = object
    `preSharedKeys`*: Value

  NoisePreSharedKeysAbsent* {.preservesDictionary.} = object
  
  `NoisePreSharedKeys`* {.preservesOr.} = object
    case orKind*: NoisePreSharedKeysKind
    of NoisePreSharedKeysKind.`present`:
        `present`*: NoisePreSharedKeysPresent

    of NoisePreSharedKeysKind.`invalid`:
        `invalid`*: NoisePreSharedKeysInvalid

    of NoisePreSharedKeysKind.`absent`:
        `absent`*: NoisePreSharedKeysAbsent

  
  SecretKeyFieldKind* {.pure.} = enum
    `present`, `invalid`, `absent`
  SecretKeyFieldPresent* {.preservesDictionary.} = object
    `secretKey`*: seq[byte]

  SecretKeyFieldInvalid* {.preservesDictionary.} = object
    `secretKey`*: Value

  SecretKeyFieldAbsent* {.preservesDictionary.} = object
  
  `SecretKeyField`* {.preservesOr.} = object
    case orKind*: SecretKeyFieldKind
    of SecretKeyFieldKind.`present`:
        `present`*: SecretKeyFieldPresent

    of SecretKeyFieldKind.`invalid`:
        `invalid`*: SecretKeyFieldInvalid

    of SecretKeyFieldKind.`absent`:
        `absent`*: SecretKeyFieldAbsent

  
  NoiseProtocolKind* {.pure.} = enum
    `present`, `invalid`, `absent`
  NoiseProtocolPresent* {.preservesDictionary.} = object
    `protocol`*: string

  NoiseProtocolInvalid* {.preservesDictionary.} = object
    `protocol`*: Value

  NoiseProtocolAbsent* {.preservesDictionary.} = object
  
  `NoiseProtocol`* {.preservesOr.} = object
    case orKind*: NoiseProtocolKind
    of NoiseProtocolKind.`present`:
        `present`*: NoiseProtocolPresent

    of NoiseProtocolKind.`invalid`:
        `invalid`*: NoiseProtocolInvalid

    of NoiseProtocolKind.`absent`:
        `absent`*: NoiseProtocolAbsent

  
  NoisePathStepDetail* = NoiseSpec
  `NoiseServiceSpec`* = Table[Symbol, Value]
  ServiceSelector* = Value
  NoiseStepDetail* = ServiceSelector
  `NoiseSpec`* = Table[Symbol, Value]
  PacketKind* {.pure.} = enum
    `complete`, `fragmented`
  PacketComplete* = seq[byte]
  PacketFragmented* = seq[seq[byte]]
  `Packet`* {.preservesOr.} = object
    case orKind*: PacketKind
    of PacketKind.`complete`:
        `complete`*: PacketComplete

    of PacketKind.`fragmented`:
        `fragmented`*: PacketFragmented

  
proc `$`*(x: NoiseDescriptionDetail | NoisePreSharedKeys | SecretKeyField |
    NoiseProtocol |
    NoisePathStepDetail |
    NoiseServiceSpec |
    NoiseSpec |
    Packet): string =
  `$`(toPreserves(x))

proc encode*(x: NoiseDescriptionDetail | NoisePreSharedKeys | SecretKeyField |
    NoiseProtocol |
    NoisePathStepDetail |
    NoiseServiceSpec |
    NoiseSpec |
    Packet): seq[byte] =
  encode(toPreserves(x))
